diff -bruN freeswan-1.9.orig/pluto/openssl.h freeswan-1.9/pluto/openssl.h
--- freeswan-1.9.orig/pluto/openssl.h	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/pluto/openssl.h	Wed May 16 10:57:20 2001
@@ -0,0 +1,101 @@
+#ifdef OPENSSL
+#ifndef OPENSSL_INC_H
+#define OPENSSL_INC_H
+
+#include <openssl/evp.h>
+#include <openssl/err.h>
+#include <openssl/pem.h>
+#include <openssl/x509.h>
+#include <openssl/x509v3.h>
+#include <openssl/safestack.h>
+
+#include <freeswan.h>
+
+#include "xmap.h"
+
+struct _x509_cert_node {
+  X509 *x;
+  struct _x509_cert_node *next;
+};
+
+typedef struct _x509_cert_node *X509_cert_list;
+
+typedef bool discrim_fn( X509 *x, STACK_OF(XMAP) *lu,
+			 struct payload_digest *const id_pld, bool strict);
+
+extern bool make_lookups(STACK_OF(XMAP) **lu, const char *spec );
+extern bool check_idtype_and_path( struct connection *c, const char *spec );
+
+extern void log_err( void );
+extern void load_cert_and_key( const char *cert, const char *key,
+			       X509 **x, EVP_PKEY **k );
+extern bool use_openssl( struct connection *c );
+extern STACK_OF(X509) *
+peer_cert_list( STACK_OF(XMAP) *lu,
+		int type,
+		X509 *cert, struct payload_digest *const id_pld,
+		bool strict );
+
+extern bool have_rsa_key( struct state *st );
+extern bool have_dss_key( struct state *st );
+extern bool have_rsa_keypair( struct state *st );
+extern bool have_elgamal_keypair( struct state *st );
+
+extern bool verify_certificate( X509 *x, STACK_OF(XMAP) *lu,
+				const char *path, bool strict );
+
+extern u_int32_t parse_options( const char *s );
+
+extern int DSA_sign_raw(unsigned char *dgst,int dlen,
+			unsigned char *sig, unsigned int *siglen, DSA *dsa);
+
+extern int DSA_verify_raw(const unsigned char *dgst,int dgst_len,
+			  unsigned char *sigbuf, int siglen, DSA *dsa);
+
+#define ERR_LIB_ELGAMAL 127
+
+#define ELGAMAL_F_ELGAMAL_PRIVATE_DECRYPT 100
+#define ELGAMAL_F_ELGAMAL_PUBLIC_ENCRYPT  101
+
+#define ELGAMAL_R_UNKNOWN_PADDING_TYPE      100
+#define ELGAMAL_R_DATA_GREATER_THAN_MOD_LEN 101
+#define ELGAMAL_R_PADDING_CHECK_FAILED      102
+
+#define ELGAMAL_PKCS1_PADDING RSA_PKCS1_PADDING
+#define ELGAMAL_PKCS1_OAEP_PADDING RSA_PKCS1_OAEP_PADDING
+#define ELGAMAL_NO_PADDING RSA_NO_PADDING
+
+#define ElGamalerr(f, r) ERR_PUT_error(ERR_LIB_ELGAMAL, (f), (r), ERR_file_name, __LINE__)
+
+void ERR_load_ElGamal_strings( void );
+int ElGamal_public_check( DSA *dsa );
+int ElGamal_public_encrypt( int flen, unsigned char *from,
+			    unsigned char *to,
+			    DSA *dsa, int padding );
+int ElGamal_private_decrypt( int flen, unsigned char *from,
+			     unsigned char *to,
+			     DSA *dsa, int padding );
+
+/* Function pointer pointing to an encryption routine */
+typedef void encryptor_fn( chunk_t *ch, struct state *c );
+
+extern bool valid_ciphertext_length( const u_int32_t len,
+				     struct connection *c );
+extern bool privkey_decrypt_chunk ( chunk_t *ch, struct state *c );
+extern bool pubkey_encrypt_chunk ( chunk_t *ch, struct state *c );
+
+/* get the other end's cert based */
+extern bool have_othercert( struct connection *c, int type );
+
+/* Macro to duplicate Private key. Used in unshare_connection_strings */
+#define EVP_PKEY_dup(pkey) \
+  (EVP_PKEY *)ASN1_dup((int (*)())i2d_PrivateKey, \
+  (char *(*)())d2i_AutoPrivateKey,(char *)pkey)
+
+/* convert EVP_PKEY to freeswan's RSA_public_key */
+extern const struct RSA_public_key *fs_RSA ( EVP_PKEY *evp_pkey );
+
+#endif
+#endif
+
+
diff -bruN freeswan-1.9.orig/pluto/openssl_defs.h freeswan-1.9/pluto/openssl_defs.h
--- freeswan-1.9.orig/pluto/openssl_defs.h	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/pluto/openssl_defs.h	Wed May 16 10:57:20 2001
@@ -0,0 +1,5 @@
+
+#define FILE_NAME_LIMIT 80
+#define PATH_NAME_LIMIT 256
+#define CERT_OPTIONS_LIMIT 128
+#define MAX_OTHER 2 /* only know about two type of certificate at the moment (RSA,DSA) */
diff -bruN freeswan-1.9.orig/pluto/packet.c freeswan-1.9/pluto/packet.c
--- freeswan-1.9.orig/pluto/packet.c	Fri Sep 15 05:09:26 2000
+++ freeswan-1.9/pluto/packet.c	Wed Jun  6 14:07:26 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: packet.c,v 1.24 2000/09/15 09:09:26 dhr Exp $
+ * RCSID $Id: packet.c,v 1.26 2001/04/09 19:48:42 dhr Exp $
  */
 
 #include <stdio.h>
@@ -20,6 +20,8 @@
 #include <netinet/in.h>
 #include <string.h>
 
+#include <freeswan.h>
+
 #include "constants.h"
 #include "defs.h"
 #include "log.h"
@@ -663,23 +665,21 @@
  */
 
 bool
-in_struct(void *struct_ptr, struct_desc *sd,
-    pb_stream *ins, pb_stream *obj_pbs)
+in_struct(void *struct_ptr, struct_desc *sd
+, pb_stream *ins, pb_stream *obj_pbs)
 {
-    char ugh[100];	/* arbitrary limit on diagnostic length */
+    err_t ugh = NULL;
     u_int8_t *cur = ins->cur;
 
-    ugh[0] = '\0';
-
     if (ins->roof - cur < (ptrdiff_t)sd->size) {
-	snprintf(ugh, sizeof(ugh), "not enough room in input packet for %s", sd->name);
+	ugh = builddiag("not enough room in input packet for %s", sd->name);
     } else {
 	u_int8_t *roof = cur + sd->size;    /* may be changed by a length field */
 	u_int8_t *outp = struct_ptr;
 	bool immediate = FALSE;
 	field_desc *fp;
 
-	for (fp = sd->fields; ugh[0] == '\0'; fp++) {
+	for (fp = sd->fields; ugh == NULL; fp++) {
 	    size_t i = fp->size;
 
 	    passert(ins->roof - cur >= (ptrdiff_t)i);
@@ -687,15 +687,15 @@
 	    passert(outp - (cur - ins->cur) == struct_ptr);
 
 #if 0
-	    DBG(DBG_PARSING, DBG_log("%d %s",
-		(int) (cur - ins->cur), fp->name == NULL? "" : fp->name));
+	    DBG(DBG_PARSING, DBG_log("%d %s"
+		, (int) (cur - ins->cur), fp->name == NULL? "" : fp->name));
 #endif
 	    switch (fp->field_type) {
 	    case ft_mbz:	/* must be zero */
 		for (; i != 0; i--) {
 		    if (*cur++ != 0) {
-			snprintf(ugh, sizeof(ugh), "byte %d of %s must be zero, but is not",
-			    (int) (cur - ins->cur), sd->name);
+                       ugh = builddiag("byte %d of %s must be zero, but is not"
+                           , (int) (cur - ins->cur), sd->name);
 			break;
 		    }
 		    *outp++ = '\0';	/* probably redundant */
@@ -723,13 +723,11 @@
 			: immediate? sd->size : n + sd->size;
 
 		    if (len < sd->size) {
-			snprintf(ugh, sizeof(ugh),
-			    "%s of %s is smaller than minimum",
-			    fp->name, sd->name);
+                       ugh = builddiag("%s of %s is smaller than minimum"
+                           , fp->name, sd->name);
 		    } else if (pbs_left(ins) < len) {
-			snprintf(ugh, sizeof(ugh),
-			    "%s of %s is larger than can fit",
-			    fp->name, sd->name);
+                       ugh = builddiag("%s of %s is larger than can fit"
+                           , fp->name, sd->name);
 		    } else {
 			roof = ins->cur + len;
 		    }
@@ -741,18 +739,17 @@
 		    /* FALL THROUGH */
 		case ft_enum:	/* value from an enumeration */
 		    if (enum_name(fp->desc, n) == NULL) {
-			snprintf(ugh, sizeof(ugh),
-			    "%s of %s has an unknown value: %lu",
-			    fp->name, sd->name, (unsigned long)n);
+                       ugh = builddiag("%s of %s has an unknown value: %lu"
+                           , fp->name, sd->name, (unsigned long)n);
 		    }
 		    /* FALL THROUGH */
 		case ft_loose_enum:	/* value from an enumeration with only some names known */
 		    break;
 		case ft_set:	/* bits representing set */
 		    if (!testset(fp->desc, n)) {
-			snprintf(ugh, sizeof(ugh),
-			    "bitset %s of %s has unknown member(s): %s",
-			    fp->name, sd->name, bitnamesof(fp->desc, n));
+			ugh = builddiag("bitset %s of %s has unknown member(s): %s"
+                            , fp->name, sd->name, bitnamesof(fp->desc, n));
+
 		    }
 		    break;
 		default:
@@ -791,8 +788,8 @@
 		    obj_pbs->cur = cur;
 		}
 		ins->cur = roof;
-		DBG(DBG_PARSING,
-		    DBG_prefix_print_struct(ins, "parse ", struct_ptr, sd, TRUE));
+		DBG(DBG_PARSING
+		    , DBG_prefix_print_struct(ins, "parse ", struct_ptr, sd, TRUE));
 		return TRUE;
 
 	    default:
@@ -818,17 +815,17 @@
     {
 	if (bytes == NULL)
 	{
-	    DBG(DBG_PARSING,
-		DBG_log("skipping %u raw bytes of %s (%s)",
-		    (unsigned) len, ins->name, name);
+	    DBG(DBG_PARSING
+		, DBG_log("skipping %u raw bytes of %s (%s)"
+		    , (unsigned) len, ins->name, name);
 		DBG_dump(name, ins->cur, len));
 	}
 	else
 	{
 	    memcpy(bytes, ins->cur, len);
-	    DBG(DBG_PARSING,
-		DBG_log("parsing %u raw bytes of %s into %s",
-		    (unsigned) len, ins->name, name);
+	    DBG(DBG_PARSING
+		, DBG_log("parsing %u raw bytes of %s into %s"
+		    , (unsigned) len, ins->name, name);
 		DBG_dump(name, bytes, len));
 	}
 	ins->cur += len;
@@ -851,20 +848,19 @@
  */
 
 bool
-out_struct(const void *struct_ptr, struct_desc *sd,
-    pb_stream *outs, pb_stream *obj_pbs)
+out_struct(const void *struct_ptr, struct_desc *sd
+, pb_stream *outs, pb_stream *obj_pbs)
 {
-    char ugh[100];	/* arbitrary limit on diagnostic length */
+    err_t ugh = NULL;
     const u_int8_t *inp = struct_ptr;
     u_int8_t *cur = outs->cur;
 
-    DBG(DBG_EMITTING,
-	DBG_prefix_print_struct(outs, "emit ", struct_ptr, sd, obj_pbs==NULL));
+    DBG(DBG_EMITTING
+	, DBG_prefix_print_struct(outs, "emit ", struct_ptr, sd, obj_pbs==NULL));
 
-    ugh[0] = '\0';
     if (outs->roof - cur < (ptrdiff_t)sd->size) {
-	snprintf(ugh, sizeof(ugh)
-	    , "not enough room left in output packet to place %s", sd->name);
+	ugh = builddiag("not enough room left in output packet to place %s"
+	    , sd->name);
     } else {
 	bool immediate = FALSE;
 	pb_stream obj;
@@ -873,7 +869,7 @@
 	obj.lenfld = NULL;  /* until a length field is discovered */
 	obj.lenfld_desc = NULL;
 
-	for (fp = sd->fields; ugh[0] == '\0'; fp++) {
+	for (fp = sd->fields; ugh == NULL; fp++) {
 	    size_t i = fp->size;
 
 	    passert(outs->roof - cur >= (ptrdiff_t)i);
@@ -881,8 +877,8 @@
 	    passert(inp - (cur - outs->cur) == struct_ptr);
 
 #if 0
-	    DBG(DBG_EMITTING, DBG_log("%d %s",
-		(int) (cur - outs->cur), fp->name == NULL? "" : fp->name);
+	    DBG(DBG_EMITTING, DBG_log("%d %s"
+		, (int) (cur - outs->cur), fp->name == NULL? "" : fp->name);
 #endif
 	    switch (fp->field_type) {
 	    case ft_mbz:	/* must be zero */
@@ -934,18 +930,16 @@
 		    /* FALL THROUGH */
 		case ft_enum:	/* value from an enumeration */
 		    if (enum_name(fp->desc, n) == NULL) {
-			snprintf(ugh, sizeof(ugh),
-			    "%s of %s has an unknown value: %lu",
-			    fp->name, sd->name, (unsigned long)n);
+                       ugh = builddiag("%s of %s has an unknown value: %lu"
+			    , fp->name, sd->name, (unsigned long)n);
 		    }
 		    /* FALL THROUGH */
 		case ft_loose_enum:	/* value from an enumeration with only some names known */
 		    break;
 		case ft_set:	/* bits representing set */
 		    if (!testset(fp->desc, n)) {
-			snprintf(ugh, sizeof(ugh),
-			    "bitset %s of %s has unknown member(s): %s",
-			    fp->name, sd->name, bitnamesof(fp->desc, n));
+			ugh = builddiag("bitset %s of %s has unknown member(s): %s"
+			    , fp->name, sd->name, bitnamesof(fp->desc, n));
 		    }
 		    break;
 		default:
@@ -1002,8 +996,8 @@
 }
 
 bool
-out_generic(u_int8_t np, struct_desc *sd,
-    pb_stream *outs, pb_stream *obj_pbs)
+out_generic(u_int8_t np, struct_desc *sd
+, pb_stream *outs, pb_stream *obj_pbs)
 {
     struct isakmp_generic gen;
 
@@ -1013,8 +1007,8 @@
 }
 
 bool
-out_generic_raw(u_int8_t np, struct_desc *sd,
-    pb_stream *outs, void *bytes, size_t len, const char *name)
+out_generic_raw(u_int8_t np, struct_desc *sd
+, pb_stream *outs, void *bytes, size_t len, const char *name)
 {
     pb_stream pbs;
 
@@ -1030,15 +1024,15 @@
 {
     if (pbs_left(outs) < len)
     {
-	loglog(RC_LOG_SERIOUS, "not enough room left to place %lu bytes of %s in %s",
-	    (unsigned long) len, name, outs->name);
+	loglog(RC_LOG_SERIOUS, "not enough room left to place %lu bytes of %s in %s"
+	    , (unsigned long) len, name, outs->name);
 	return FALSE;
     }
     else
     {
-	DBG(DBG_EMITTING,
-	    DBG_log("emitting %u raw bytes of %s into %s",
-		(unsigned) len, name, outs->name);
+	DBG(DBG_EMITTING
+	    , DBG_log("emitting %u raw bytes of %s into %s"
+		, (unsigned) len, name, outs->name);
 	    DBG_dump(name, bytes, len));
 	memcpy(outs->cur, bytes, len);
 	outs->cur += len;
@@ -1056,8 +1050,8 @@
     }
     else
     {
-	DBG(DBG_EMITTING, DBG_log("emitting %u zero bytes of %s into %s",
-	    (unsigned) len, name, outs->name));
+	DBG(DBG_EMITTING, DBG_log("emitting %u zero bytes of %s into %s"
+	    , (unsigned) len, name, outs->name));
 	memset(outs->cur, 0x00, len);
 	outs->cur += len;
 	return TRUE;
@@ -1078,8 +1072,8 @@
 
 	if (pbs->lenfld_desc->field_type == ft_lv)
 	    len -= sizeof(struct isakmp_attribute);
-	DBG(DBG_EMITTING, DBG_log("emitting length of %s: %lu",
-	    pbs->name, (unsigned long) len));
+	DBG(DBG_EMITTING, DBG_log("emitting length of %s: %lu"
+	    , pbs->name, (unsigned long) len));
 	while (i-- != 0) {
 	    pbs->lenfld[i] = (u_int8_t)len;
 	    len >>= BITS_PER_BYTE;
diff -bruN freeswan-1.9.orig/pluto/packet.h freeswan-1.9/pluto/packet.h
--- freeswan-1.9.orig/pluto/packet.h	Fri Sep 15 05:09:26 2000
+++ freeswan-1.9/pluto/packet.h	Wed Jun  6 14:08:33 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: packet.h,v 1.16 2000/09/15 09:09:26 dhr Exp $
+ * RCSID $Id: packet.h,v 1.17 2001/04/04 20:02:25 dhr Exp $
  */
 
 /* a struct_desc describes a structure for the struct I/O routines.
@@ -122,14 +122,36 @@
  * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
  * !                            Length                             !
  * +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
- * Although the drafts are a little unclear, all messages should
- * be padded with enough 0x00 bytes to make the length a multiple of
- * (a) a multiple of 4 octets in length (source:
- *     draft-ietf-ipsec-isakmp-09.txt 3, but ??? no padding value is
- *     specified), and
- * (b) the encryption block size (if encrypted) (source:
- *     draft-ietf-ipsec-isakmp-oakley-07, 5.3 and Appendix B)
- * ??? It is not clear that if (b) applies, (a) always makes sense.
+ * Although the drafts are a little unclear, there are a few
+ * places that specify that messages should be padded with 0x00
+ * octets (bytes) to make the length a multiple of something.
+ *
+ * RFC 2408 "ISAKMP" 3.6 specifies that all messages will be
+ * padded to be a multiple of 4 octets in length.
+ * ??? This looks vestigial, and we ignore this requirement.
+ *
+ * RFC 2409 "IKE" Appedix B specifies:
+ *     Each message should be padded up to the nearest block size
+ *     using bytes containing 0x00.
+ * ??? This does not appear to be limited to encrypted messages,
+ * but it surely must be: the block size is meant to be the encryption
+ * block size, and that is meaningless for a non-encrypted message.
+ *
+ * RFC 2409 "IKE" 5.3 specifies:
+ *     Encrypted payloads are padded up to the nearest block size.
+ *     All padding bytes, except for the last one, contain 0x00. The
+ *     last byte of the padding contains the number of the padding
+ *     bytes used, excluding the last one. Note that this means there
+ *     will always be padding.
+ * ??? This is nuts since payloads are not padded, messages are.
+ * It also contradicts Appendix B.  So we ignore it.
+ *
+ * Summary: we pad encrypted output messages with 0x00 to bring them
+ * up to a multiple of the encryption block size.  On input, we require
+ * that any encrypted portion of a message be a multiple of the encryption
+ * block size.   After any decryption, we ignore padding (any bytes after
+ * the first payload that specifies a next payload of none; we don't
+ * require them to be zero).
  */
 
 struct isakmp_hdr
diff -bruN freeswan-1.9.orig/pluto/preshared.c freeswan-1.9/pluto/preshared.c
--- freeswan-1.9.orig/pluto/preshared.c	Thu Feb 22 16:27:59 2001
+++ freeswan-1.9/pluto/preshared.c	Wed Jun  6 14:18:25 2001
@@ -11,7 +11,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: preshared.c,v 1.42.2.2 2001/02/22 21:27:59 henry Exp $
+ * RCSID $Id: preshared.c,v 1.50 2001/04/09 19:48:42 dhr Exp $
  */
 
 #include <stdio.h>
@@ -176,8 +176,13 @@
 
 const char *shared_secrets_file = SHARED_SECRETS_FILE;
 
+struct id_list {
+    struct id id;
+    struct id_list *next;
+};
+
 struct secret {
-    struct id *ids;
+    struct id_list *ids;
     enum PrivateKeyKind kind;
     union {
 	chunk_t preshared_secret;
@@ -203,14 +208,11 @@
     unsigned int best_match = 0;
     struct secret *best = NULL;
     struct secret *s;
-    struct id
-	*my_id = &c->this.id,
-	rw_id,
-	*his_id = &c->that.id;
-
-    if (c->rw_state == rwcs_instance
-    && (c->that.id.kind == ID_IPV4_ADDR || c->that.id.kind == ID_IPV6_ADDR)
-    && sameaddr(&c->that.id.ip_addr, &c->that.host_addr))
+    struct id *my_id = &c->this.id
+       , rw_id
+       , *his_id = &c->that.id;
+
+    if (his_id_was_instantiated(c))
     {
 	/* roadwarrior: replace him with 0.0.0.0 */
 	rw_id.kind = c->that.id.kind;
@@ -234,14 +236,14 @@
 	    else
 	    {
 		/* check if both ends match ids */
-		struct id *i;
+		struct id_list *i;
 
 		for (i = s->ids; i != NULL; i = i->next)
 		{
-		    if (same_id(my_id, i))
+			if (same_id(my_id, &i->id))
 			match |= match_me;
 
-		    if (same_id(his_id, i))
+			if (same_id(his_id, &i->id))
 			match |= match_him;
 		}
 
@@ -544,8 +546,6 @@
 {
     char buf[2048];	/* limit on size of binary representation of key */
     err_t ugh = NULL;
-    err_t ugh_extra = "";
-    char ugh_space[100];	/* perhaps enough space */
 
     if (*tok == '"' || *tok == '\'')
     {
@@ -573,10 +573,7 @@
 	    if (ugh != NULL)
 	    {
 		/* atobytes didn't like PSK data */
-		snprintf(ugh_space, sizeof(ugh_space)
-		    , "PSK data malformed (%s): ", ugh);
-		ugh = ugh_space;
-		ugh_extra = tok;
+		ugh = builddiag("PSK data malformed (%s): %s", ugh, tok);
 	    }
 	    else
 	    {
@@ -613,8 +610,8 @@
 		}
 		else if (!tokeqword(p->name))
 		{
-		    ugh = p->name;
-		    ugh_extra = " keyword not found where expected in RSA key";
+		    ugh = builddiag("%s keyword not found where expected in RSA key"
+                       , p->name);
 		}
 		else if (!(shift()
 		&& (!tokeq(":") || shift())))	/* ignore optional ":" */
@@ -624,10 +621,7 @@
 		else if (NULL != (ugh = atobytes(tok, sfp->cur - tok, buf, sizeof(buf), &sz)))
 		{
 		    /* in RSA key, atobytes didn't like */
-		    snprintf(ugh_space, sizeof(ugh_space)
-			, "RSA data malformed (%s): ", ugh);
-		    ugh = ugh_space;
-		    ugh_extra = tok;
+		    ugh = builddiag("RSA data malformed (%s): %s", ugh, tok);
 		}
 		else
 		{
@@ -667,14 +661,13 @@
     }
     else
     {
-	ugh = "unrecognized key format: ";
-	ugh_extra = tok;
+	ugh = builddiag("unrecognized key format: %s", tok);
     }
 
     if (ugh != NULL)
     {
-	loglog(RC_LOG_SERIOUS, "\"%s\" line %d: %s%s"
-	    , sfp->filename, sfp->lino, ugh, ugh_extra);
+	loglog(RC_LOG_SERIOUS, "\"%s\" line %d: %s"
+	    , sfp->filename, sfp->lino, ugh);
     }
     else if (flushline("expected record boundary in key"))
     {
@@ -775,13 +768,13 @@
 
 		    if (tokeq("%any"))
 		    {
-			memset(&id, 0, sizeof(id));
+			id = empty_id;
 			id.kind = ID_IPV4_ADDR;
 			ugh = anyaddr(AF_INET, &id.ip_addr);
 		    }
 		    else if (tokeq("%any6"))
 		    {
-			memset(&id, 0, sizeof(id));
+			id = empty_id;
 			id.kind = ID_IPV6_ADDR;
 			ugh = anyaddr(AF_INET6, &id.ip_addr);
 		    }
@@ -797,8 +790,11 @@
 		    }
 		    else
 		    {
-			struct id *i = clone_id(&id);
+			struct id_list *i = alloc_thing(struct id_list
+                           , "id_list");
 
+                       i->id = id;
+                       unshare_id_content(&i->id);
 			i->next = s->ids;
 			s->ids = i;
 			/* DBG_log("id type %d: %s %.*s", i->kind, ip_str(&i->ip_addr), (int)i->name.len, i->name.ptr); */
@@ -888,6 +884,7 @@
 	(void) shift();	/* prime tok */
 	(void) flushline("file starts with indentation (continuation notation)");
 	process_secret_records();
+	fclose(pos.fp);
     }
 
     sfp = pos.previous;	/* restore old state */
@@ -904,13 +901,14 @@
 
 	for (s = secrets; s != NULL; s = ns)
 	{
-	    struct id *i, *ni;
+	    struct id_list *i, *ni;
 
 	    ns = s->next;	/* grab before freeing s */
 	    for (i = s->ids; i != NULL; i = ni)
 	    {
 		ni = i->next;	/* grab before freeing i */
-		free_id(i);
+		free_id_content(&i->id);
+                pfree(i);
 	    }
 	    switch (s->kind)
 	    {
@@ -946,7 +944,7 @@
 /* public key machinery */
 
 struct pubkeyrec {
-    struct id *id;
+    struct id id;
     enum pubkey_alg alg;
     union {
 	struct RSA_public_key rsa;
@@ -963,7 +961,7 @@
 
     pubkeys = p->next;
 
-    free_id(p->id);
+    free_id_content(&p->id);
 
     /* algorithm-specific freeing */
     switch (p->alg)
@@ -1062,7 +1060,7 @@
 
     for (pp = &pubkeys; (p = *pp) != NULL; pp = &p->next)
     {
-	if (same_id(id, p->id) && p->alg == alg)
+	if (same_id(id, &p->id) && p->alg == alg)
 	{
 	    /* we have a winner: bring it to front, return key */
 
@@ -1137,7 +1135,9 @@
 	passert(FALSE);
     }
 
-    p->id = clone_id(id);
+    p->id = *id;
+    unshare_id_content(&p->id);
+
     p->alg = alg;
 
     /* just before installing, delete any previous key of this type
diff -bruN freeswan-1.9.orig/pluto/preshared.h freeswan-1.9/pluto/preshared.h
--- freeswan-1.9.orig/pluto/preshared.h	Fri Aug 18 01:20:18 2000
+++ freeswan-1.9/pluto/preshared.h	Wed May 16 10:57:20 2001
@@ -29,7 +29,7 @@
 
 enum PrivateKeyKind {
     PPK_PSK,
-    /* PPK_DSS, */	/* not implemented */
+    /* PPK_DSS,     Still unsupported */
     PPK_RSA
 };
 
diff -bruN freeswan-1.9.orig/pluto/rnd.c freeswan-1.9/pluto/rnd.c
--- freeswan-1.9.orig/pluto/rnd.c	Tue Jul 25 11:21:26 2000
+++ freeswan-1.9/pluto/rnd.c	Wed Jun  6 15:04:46 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: rnd.c,v 1.13 2000/07/25 15:21:26 dhr Exp $
+ * RCSID $Id: rnd.c,v 1.15 2001/03/23 23:17:51 dhr Exp $
  */
 
 /* A true random number generator (we hope)
@@ -57,6 +57,8 @@
 #include <sys/time.h>
 #include <fcntl.h>
 
+#include <freeswan.h>
+
 #include "sha1.h"
 #include "constants.h"
 #include "defs.h"
@@ -104,6 +106,14 @@
 
 #else /* !USE_DEV_RANDOM */
 
+/* Generate (what we hope is) a true random byte using the clock skew trick.
+ * Note: this code is not maintained!  In particular, LINUX signal(2)
+ * semantics changed with glibc2 (and not for the better).  It isn't clear
+ * that this code will work.  We keep the code because someday it might
+ * come in handy.
+ */
+# error "This code is not maintained.  Please define USE_DEV_RANDOM."
+
 static volatile sig_atomic_t i, j, k;
 
 /* timer signal handler */
@@ -118,7 +128,6 @@
 	signal(SIGVTALRM, rnd_handler);
 }
 
-/* Generate (what we hope is) a true random byte using the clock skew trick */
 static u_char
 generate_rnd_byte(void)
 {
diff -bruN freeswan-1.9.orig/pluto/server.c freeswan-1.9/pluto/server.c
--- freeswan-1.9.orig/pluto/server.c	Tue Jan 23 18:09:31 2001
+++ freeswan-1.9/pluto/server.c	Wed Jun  6 15:20:02 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: server.c,v 1.55 2001/01/23 23:09:31 dhr Exp $
+ * RCSID $Id: server.c,v 1.60 2001/04/07 18:22:18 dhr Exp $
  */
 
 #include <stdio.h>
@@ -53,7 +53,6 @@
 #include "kernel_comm.h"
 #include "whack.h"	/* for RC_LOG_SERIOUS */
 
-#include <signal.h>
 #include <pfkeyv2.h>
 #include <pfkey.h>
 
@@ -116,6 +115,73 @@
 
 /* Initialize the interface sockets. */
 
+static void
+mark_ifaces_dead(void)
+{
+    struct iface *p;
+
+    for (p = interfaces; p != NULL; p = p->next)
+       p->change = IFN_DELETE;
+}
+
+static void
+free_dead_ifaces(void)
+{
+    struct iface *p;
+    bool some_dead = FALSE
+       , some_new = FALSE;
+
+    for (p = interfaces; p != NULL; p = p->next)
+    {
+       if (p->change == IFN_DELETE)
+       {
+           log("shutting down interface %s/%s %s"
+               , p->vname, p->rname, ip_str(&p->addr));
+           some_dead = TRUE;
+       }
+       else if (p->change == IFN_ADD)
+       {
+           some_new = TRUE;
+       }
+    }
+
+    if (some_dead)
+    {
+       struct iface **pp;
+
+       release_dead_interfaces();
+       for (pp = &interfaces; (p = *pp) != NULL; )
+       {
+           if (p->change == IFN_DELETE)
+           {
+               *pp = p->next;  /* advance *pp */
+               pfree(p->vname);
+               pfree(p->rname);
+               close(p->fd);
+               pfree(p);
+           }
+           else
+           {
+               pp = &p->next;  /* advance pp */
+           }
+       }
+    }
+
+    /* this must be done after the release_dead_interfaces
+     * in case some to the newly unoriented connections can
+     * become oriented here.
+     */
+    if (some_dead || some_new)
+       check_orientations();
+}
+
+void
+free_ifaces(void)
+{
+    mark_ifaces_dead();
+    free_dead_ifaces();
+}
+
 struct raw_iface {
     ip_address addr;
     char name[IFNAMSIZ + 20];	/* what would be a safe size? */
@@ -133,12 +199,9 @@
     struct ifconf ifconf;
     struct ifreq buf[300];	/* for list of interfaces -- arbitrary limit */
     struct raw_iface *rifaces = NULL;
+    int master_sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP);    /* Get a UDP socket */
 
     /* get list of interfaces with assigned IPv4 addresses from system */
-    {
-	/* Get a UDP socket */
-	int master_sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP);
-	ip_address any;
 
 	if (master_sock == -1)
 	    exit_log_errno((e, "socket() failed in find_raw_ifaces4()"));
@@ -148,28 +211,30 @@
 	    exit_log_errno((e, "setsockopt() in find_raw_ifaces4()"));
 
 	/* bind the socket */
+    {
+       ip_address any;
+
 	(void)anyaddr(AF_INET, &any);
 	setportof(htons(pluto_port), &any);
 	if (bind(master_sock, sockaddrof(&any), sockaddrlenof(&any)) < 0)
 	    exit_log_errno((e, "bind() failed in find_raw_ifaces4()"));
+    }
 
-	/* Get local interfaces */
+    /* Get local interfaces.  See netdevice(7). */
 	ifconf.ifc_len = sizeof(buf);
 	ifconf.ifc_buf = (void *) buf;
-	memset(buf, '\0', sizeof(buf));
+    zero(buf);
 
 	if (ioctl(master_sock, SIOCGIFCONF, &ifconf) == -1)
 	    exit_log_errno((e, "ioctl(SIOCGIFCONF) in find_raw_ifaces4()"));
 
-	close(master_sock);
-    }
-
     /* Add an entry to rifaces for each interesting interface. */
     for (j = 0; (j+1) * sizeof(*buf) <= (size_t)ifconf.ifc_len; j++)
     {
 	struct raw_iface ri;
 	const struct sockaddr_in *rs = (struct sockaddr_in *) &buf[j].ifr_addr;
 	err_t ugh;
+	struct ifreq auxinfo;
 
 	/* ignore all but AF_INET interfaces */
 	if (rs->sin_family != AF_INET)
@@ -179,6 +244,16 @@
 	memcpy(ri.name, buf[j].ifr_name, IFNAMSIZ);
 	ri.name[IFNAMSIZ] = '\0';
 
+       /* Find out stuff about this interface.  See netdevice(7). */
+       zero(&auxinfo); /* paranoia */
+       memcpy(auxinfo.ifr_name, buf[j].ifr_name, IFNAMSIZ);
+       if (ioctl(master_sock, SIOCGIFFLAGS, &auxinfo) == -1)
+           exit_log_errno((e
+               , "ioctl(SIOCGIFFLAGS) for %s in find_raw_ifaces4()"
+               , ri.name));
+       if (!(auxinfo.ifr_flags & IFF_UP))
+           continue;   /* ignore an interface that isn't UP */
+
 	/* ignore unconfigured interfaces */
 	if (rs->sin_addr.s_addr == 0)
 	    continue;
@@ -193,6 +268,8 @@
 	rifaces = clone_thing(ri, "struct raw_iface");
     }
 
+    close(master_sock);
+
     return rifaces;
 }
 
@@ -244,9 +321,7 @@
 		, "%4hx%4hx%4hx%4hx%4hx%4hx%4hx%4hx"
 		  " %02x %02x %02x %02x %20s\n"
 		, xb+0, xb+1, xb+2, xb+3, xb+4, xb+5, xb+6, xb+7
-		, &if_idx, &plen
-		, &scope, &dad_status
-		, ri.name);
+		, &if_idx, &plen, &scope, &dad_status, ri.name);
 	    err_t ugh;
 
 	    /* ??? we should diagnose any problems */
@@ -275,10 +350,9 @@
     return rifaces;
 }
 
-static struct iface *
-process_raw_ifaces(struct iface *new_ifaces_tail, struct raw_iface *rifaces)
+static void
+process_raw_ifaces(struct raw_iface *rifaces)
 {
-    struct iface *new_ifaces = new_ifaces_tail;
     struct raw_iface *ifp;
 
     /* Find all virtual/real interface pairs.
@@ -430,8 +504,9 @@
 		    q->vname = clone_str(v->name, "virtual device name");
 		    q->addr = ifp->addr;
 		    q->fd = fd;
-		    q->next = new_ifaces;
-		    new_ifaces = q;
+                   q->next = interfaces;
+                   q->change = IFN_ADD;
+                   interfaces = q;
 		    log("adding interface %s/%s %s"
 			, q->vname, q->rname, ip_str(&q->addr));
 		    break;
@@ -442,10 +517,8 @@
 		&& streq(q->vname, v->name)
 		&& sameaddr(&q->addr, &ifp->addr))
 		{
-		    /* matches -- steal old entry */
-		    *p = q->next;
-		    q->next = new_ifaces;
-		    new_ifaces = q;
+                   /* matches -- rejuvinate old entry */
+                   q->change = IFN_KEEP;
 		    break;
 		}
 
@@ -463,42 +536,29 @@
 	rifaces = t->next;
 	pfree(t);
     }
-
-    return new_ifaces;
 }
 
 void
 find_ifaces(void)
 {
-    struct iface *new_ifaces = NULL;
+    mark_ifaces_dead();
+    process_raw_ifaces(find_raw_ifaces4());
+    process_raw_ifaces(find_raw_ifaces6());
 
-    new_ifaces = process_raw_ifaces(new_ifaces, find_raw_ifaces4());
-    new_ifaces = process_raw_ifaces(new_ifaces, find_raw_ifaces6());
+    free_dead_ifaces();            /* ditch remaining old entries */
 
-    free_ifaces();	    /* ditch remaining old entries */
-    interfaces = new_ifaces;
     if (interfaces == NULL)
 	loglog(RC_LOG_SERIOUS, "no public interfaces found");
 }
 
 void
-free_ifaces(void)
+show_ifaces_status(void)
 {
-    struct iface *p = interfaces;
-
-    while (p != NULL)
-    {
-	struct iface *q = p->next;
+    struct iface *p;
 
-	log("shutting down interface %s/%s %s"
+    for (p = interfaces; p != NULL; p = p->next)
+       whack_log(RC_COMMENT, "interface %s/%s %s"
 	    , p->vname, p->rname, ip_str(&p->addr));
-	release_interface(p);
-	pfree(p->vname);
-	pfree(p->rname);
-	close(p->fd);
-	pfree(p);
-	p = q;
-    }
 }
 
 static volatile sig_atomic_t hupflag = FALSE;
@@ -507,7 +567,6 @@
 huphandler(int sig UNUSED)
 {
     hupflag = TRUE;
-    (void)signal(SIGHUP, &huphandler);
 }
 
 /* call_server listens for incoming ISAKMP packets and Whack messages,
@@ -521,7 +580,16 @@
 
 
     /* dumb folks think poking any daemon with SIGHUP is polite */
-    (void)signal(SIGHUP, &huphandler);
+    {
+       int r;
+       struct sigaction act;
+
+       act.sa_handler = &huphandler;
+       sigemptyset(&act.sa_mask);
+       act.sa_flags = 0;       /* no SA_ONESHOT, no SA_RESTART, no nothing */
+       r = sigaction(SIGHUP, &act, NULL);
+       passert(r == 0);
+    }
 
     for (;;)
     {
diff -bruN freeswan-1.9.orig/pluto/server.h freeswan-1.9/pluto/server.h
--- freeswan-1.9.orig/pluto/server.h	Tue Jan 23 18:09:31 2001
+++ freeswan-1.9/pluto/server.h	Wed Jun  6 15:22:38 2001
@@ -11,7 +11,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: server.h,v 1.13 2001/01/23 23:09:31 dhr Exp $
+ * RCSID $Id: server.h,v 1.15 2001/04/06 20:30:08 dhr Exp $
  */
 
 extern struct sockaddr_un ctl_addr;	/* address of control (whack) socket */
@@ -34,10 +34,12 @@
     ip_address addr;	/* interface IP address */
     int fd;	/* file descriptor of socket for IKE UDP messages */
     struct iface *next;
+    enum { IFN_ADD, IFN_KEEP, IFN_DELETE } change;
 };
 
 extern struct iface *interfaces;	/* public interfaces */
 
 extern void find_ifaces(void);
+extern void show_ifaces_status(void);
 extern void free_ifaces(void);
 extern void call_server(void);
